freeslot("SPR_LOAE", "sfx_loacrt")


BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "A Mighty Power",
  description = {"A Great Power wants", "to see your strength..."},
  level = 99,
  music = "GREPWR",
  time = TICRATE*60*55,
  items = {{"tearalbalm", 50}, {"spcharge3", 50}, {"curiabalm", 30}, {"recuriabalm", 20}, {"revbalm", 30}, {"celbalm", 20}, {"hypercombiring", 30}, {"soma", 5}},
  waves = {
			{"loa"},
		},
}

enemyList["loa"] = {
		name = "Loa Erebonius",
		skillchance = 95,	
		level = 100,
		hp = 14000,
		sp = 9999,
		strength = 85,
		magic = 85,
		endurance = 70,
		luck = 70,
		agility = 72,
		melee_natk = "clawstrike",	
		thinker = generalEnemyThinker,
		scale = FRACUNIT*2,
		boss = true,
		endboss = true,
		turns = 2,

		anim_stand = 		{SPR_LOAE, A, 4},				-- standing
		anim_stand_hurt =	{SPR_LOAE, A, 4},					-- standing (low HP) *
		anim_stand_bored =	{SPR_LOAE, A, 4},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_LOAE, A, 4},				-- guarding
		anim_move =			{SPR_LOAE, A, 4},	-- moving
		anim_run =			{SPR_LOAE, A, 4},	-- guess what
		anim_atk =			{SPR_LOAE, A, 4},			-- attacking
		anim_aoa_end =		{SPR_LOAE, A, 4},			-- jumping out of all-out attack
		anim_hurt =			{SPR_LOAE, A, 4},				-- taking damage
		anim_getdown =		{SPR_LOAE, A, 4},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LOAE, A, 4},					-- is down
		anim_getup =		{SPR_LOAE, A, 4},			-- gets up from down
		anim_death =		{SPR_LOAE, A, 4},					-- dies
		anim_revive =		{SPR_LOAE, A, 4},			-- gets revived
		anim_evoker =		{SPR_LOAE, A, 4},
		anim_evoker_shoot = {SPR_LOAE, A, 4},
		
		vfx_crit = {"sfx_loacrt"},
		
		hudcutin = "LOAE_A",	-- cut in

		
		skills = {"garkuti", "finaltrialmap", "blesatu", "kilati", "jukait", "fors", "clawstrike", "vel-da-doop", "vilna-ya", "ark-zok-onkeim", "volzello-anaia", "van-ku-oh", "innocence_arc", "death_scream_alt", "goldenhalo"}
}

attackDefs["clawstrike"] = {
		name = "Claw Strike",
		type = ATK_SLASH,
		power = 400,
		accuracy = 90,
		costtype = CST_SP,
		cost = 48,
		critical = 5,
		technical = COND_FEAR,
		desc = "Heavy slash damage to \nall enemies.\nHeal for 5%",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			if timer == 1
				mo.totdam = 0
			end

			for i = 1, #hittargets
				local color = SKINCOLOR_BLACK
				local target = hittargets[i]
				local time = timer - (i-1)*6

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end

				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						mo.totdam = $1+target.damagetaken
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end

			if timer == 55 + (#hittargets-1)*6
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				mo.atk_attacker = mo
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				ANIM_set(mo, mo.guard, true)
				playSound(mo.battlen, sfx_heal3)
				damageObject(mo, -(mo.totdam/4), DMG_NORMAL)
			elseif timer == 80 + 6*(#hittargets-1)
				mo.totdam = nil
				return true
			end
		end,
		critanim = function(mo, targets, hittargets, timer)
			local cam = server.P_BattleStatus[mo.battlen].cam
			if timer == 1
				mo.totdam = 0
			end

			for i = 1, #hittargets
				local color = SKINCOLOR_BLACK
				local target = hittargets[i]
				local time = timer - (i-1)*6

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end

				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						mo.totdam = $1+target.damagetaken
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end

			if timer == 55 + (#hittargets-1)*6
				local cx = mo.x + 256*cos(mo.angle)
				local cy = mo.y + 256*sin(mo.angle)
				mo.atk_attacker = mo
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				ANIM_set(mo, mo.guard, true)
				playSound(mo.battlen, sfx_heal4)
				damageObject(mo, -(mo.totdam/2), DMG_NORMAL)
			elseif timer == 80 + 6*(#hittargets-1)
				mo.totdam = nil
				return true
			end
		end,
}

attackDefs["vel-da-doop"] = {
		name = "Vel-da-doop",
		type = ATK_ALMIGHTY,
		power = 300,
		accuracy = 90,
		costtype = CST_SP,
		status = COND_SLEEP,
		statuschance = 10,
		cost = 30,
		desc = "Almighty Damage to all enemies.\nVery high odds of Sleep",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			if timer == 10
				mo.dbs = {}
				playSound(mo.battlen, sfx_cboom)
				-- ready smoke table
			end

			-- spawn said smoke:
			if timer >= 10 and timer <= TICRATE + TICRATE/2
			and mo.dbs

				for i = 1, 8
					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state = S_CDUST1
					s.color = SKINCOLOR_BLACK
					s.angle = P_RandomRange(0, 359)*ANG1
					s.scale = FRACUNIT*3
					s.scalespeed = FRACUNIT/6
					s.destscale = FRACUNIT*12
					s.dist = 0
					s.tics = 18
					mo.dbs[#mo.dbs+1] = s
				end
			end

			-- rotate the smoke
			if mo.dbs and #mo.dbs
				for i = 1, #mo.dbs do
					local s = mo.dbs[i]
					if not s or not s.valid continue end	-- don't care

					s.angle = $+ ANG1*10
					s.dist = min(1024, $+32)

					P_TeleportMove(s, mo.x + s.dist *cos(s.angle), mo.y + s.dist*sin(s.angle), s.floorz)

					if not P_RandomRange(0, 30)
						local t = P_SpawnMobj(s.x, s.y, s.z, MT_THOK)
						t.color = SKINCOLOR_BLACK
						t.frame = $|FF_FULLBRIGHT
						t.momz = P_RandomRange(4, 8)*FRACUNIT
						t.destscale = 1
						t.tics = TICRATE
					end
				end
			end

			-- hit targets
			for i = 1, #hittargets
				local target = hittargets[i]
				local t = timer - 6*(i-1)

				if t == TICRATE - TICRATE/4
					local dmg = max(1, target.hp/4)
					if target.boss
						dmg = nil
					end

					damageObject(target)
				end
			end

			if timer == TICRATE*2 - TICRATE/4 + (#hittargets-1)*6
				return true
			end
		end,
}

attackDefs["volzello-anaia"] = {
		name = "Volzello-anaia",
		type = ATK_ALMIGHTY,
		power = 1550,
		accuracy = 90,
		costtype = CST_SP,
		cost = 30,
		desc = "Almighty Damage to all enemies.\nDoes a lot of damage",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies

				if timer == 10
					playSound(mo.battlen, sfx_megi3)

					-- get them cards ready

					-- first row
					mo.hcard = {}
					for i = 1, 6
						local ang = (360/6 *i)*ANG1
						local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.z, MT_DUMMY)
						c.sprite = SPR_THOK
						c.frame = A|FF_FULLBRIGHT
						c.color = SKINCOLOR_BLACK
						c.scale = 1
						c.destscale = FRACUNIT*5
						c.scalespeed = (FRACUNIT*5)/80
						c.angle = ang+ANG1*90
						c.tics = -1
						mo.hcard[#mo.hcard+1] = c
					end
				elseif timer == 20
					-- get them cards ready

					-- first row
					mo.hcard2 = {}
					for i = 1, 10
						local ang = (360/10 *i)*ANG1
						local c = P_SpawnMobj(avgx + 320*cos(ang), avgy + 320*sin(ang), mo.z, MT_DUMMY)
						c.sprite = SPR_THOK
						c.frame = A|FF_FULLBRIGHT
						c.color = SKINCOLOR_WHITE
						c.angle = ang+ANG1*90
						c.tics = -1
						c.scale = 1
						c.destscale = FRACUNIT*5
						c.scalespeed = (FRACUNIT*5)/80
						mo.hcard2[#mo.hcard2+1] = c
					end
				end

				local ct = mo.hcard
				while ct

					for i = 1, #ct
						local c = ct[i]

						if c.appeartimer == nil
							c.appeartimer = 9
						end
						c.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE | (c.appeartimer<<FF_TRANSSHIFT)
						c.appeartimer = max(4, $-1)

						if timer >= TICRATE*3/2
						and leveltime & 1
							c.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
						end

						if c.appeartimer <= 4

							c.rspeed = $ or 1
							if leveltime%4 == 0
								c.rspeed = min(25, $+1)
							end

							if ct == mo.hcard2
								c.angle = $ + c.rspeed*ANG1
							else
								c.angle = $ - c.rspeed*ANG1
							end	-- rotate

							--update pos

							if leveltime & 1
								local g = P_SpawnGhostMobj(c)
								g.fuse = 2
							end

							local dist = ct == mo.hcard2 and 320 or 256
							P_TeleportMove(c, avgx + dist*cos(c.angle - ANG1*90), avgy + dist*sin(c.angle - ANG1*90), c.z)
						end

						if timer == TICRATE*5/2
							P_InstaThrust(c, c.angle - ANG1*90, 48*FRACUNIT)
							c.fuse = TICRATE
						end
					end


					-- fuck you
					if ct == mo.hcard2
						break
					else
						ct = mo.hcard2
					end
				end

				if timer >= 20

					if timer == TICRATE
						playSound(mo.battlen, sfx_zio5)
					end

					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 256
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_WHITE
						aura.momz = P_RandomRange(4, 16)*FRACUNIT
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
					end
				end

				if timer == TICRATE*5/2
					mo.hcard = nil
					mo.hcard2 = nil

					playSound(mo.battlen, sfx_tiexp)

					for k,v in ipairs(hittargets)
						damageObject(v)
					end
				end

				if timer >= TICRATE*5/2
				and timer <= TICRATE*4

					for i = 1, 16
						local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_SUPERSPARK)
						boom.momz = P_RandomRange(16, 64)*FRACUNIT
						boom.scale = FRACUNIT*2
					end
				end

				if timer == TICRATE*4
					return true
				end
		end,
}

attackDefs["van-ku-oh"] = {
		name = "Van-ku-oh",
		type = ATK_ALMIGHTY,
		costtype = CST_SP,
		cost = 24,
		desc = "Severe Almighty damage to\nall enemies.",
		target = TGT_ALLENEMIES,
		accuracy = 100,
		power = 750,
		anim = 			function(mo, targets, hittargets, timer)

							local avgx = 0
							local avgy = 0

							for i = 1, #hittargets
								local t = hittargets[i]

								avgx = $+ t.x/FRACUNIT
								avgy = $+ t.y/FRACUNIT

								local time = timer - 10*(i-1)

								if time >= 20 and time <= 30
								and (time%5) == 0

									local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
									s.color = SKINCOLOR_BLACK
									s.state = S_MEGISTAR1
									s.scale = $*2 + P_RandomRange(0, 65535)
									playSound(mo.battlen, sfx_hamas1)
								end
							end

							if timer == 40 + 10*(#hittargets-1)
								-- get average coords from what we had before
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT

								local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*128, MT_DUMMY)
								s.color = SKINCOLOR_BLACK
								s.state = S_MEGISTAR1
								s.scale = FRACUNIT*4
								playSound(mo.battlen, sfx_hamas2)
							elseif timer == 50 + 10*(#hittargets-1)
								-- explode lol
								playSound(mo.battlen, sfx_megi6)
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT
								local an = 0
								for i = 1, 32

									local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.color = SKINCOLOR_BLACK
									s.state = S_CDUST1
									s.scale = FRACUNIT*4
									s.fuse = TICRATE*3
									P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

									s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.color = SKINCOLOR_BLACK
									s.state = S_CDUST1
									s.scale = FRACUNIT*4
									s.fuse = TICRATE*3
									P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

									an = $ + (360/32)
								end

								for i = 1, #hittargets do
									damageObject(hittargets[i])
								end
							elseif timer == 100 + 10*(#hittargets-1)
								return true
							end
						end

}

attackDefs["ark-zok-onkeim"] = {
		name = "Ark-zok-onkeim",
		type = ATK_ALMIGHTY,
		power = 1000,
		accuracy = 999,
		costtype = CST_SP,
		cost = 16,
		status = COND_FREEZE,
		statuschance = 100,
		desc = "Drains a Enemy's HP and Insta Freezes it",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
					local target = hittargets[1]

					if timer >= 20 and timer <= 40

						if timer == 20
							playSound(mo.battlen, sfx_endrn)
                        elseif timer == 30
                            damageObject(target, target.maxhp/10)
                            mo.buf_damage = target.damagetaken*5
                        end

						for i = 1,2
							local thok = P_SpawnMobj(target.x, target.y, target.z+mo.height/2, MT_DUMMY)
							thok.color = SKINCOLOR_PERIDOT
							thok.momx = P_RandomRange(-10, 10)*FRACUNIT
							thok.momy = P_RandomRange(-10, 10)*FRACUNIT
							thok.momz = P_RandomRange(-10, 10)*FRACUNIT
							thok.scale = FRACUNIT/10
							thok.destscale = FRACUNIT*2
						end

					elseif timer >= 50 and timer <= 70

						if timer == 60
						and target ~= mo
							mo.atk_attacker = mo
							playSound(mo.battlen, sfx_lsheal)
							damageObject(mo, -mo.buf_damage, DMG_NORMAL)
						end

						local h_angle = P_RandomRange(1, 359)*ANG1
						local v_angle = P_RandomRange(1, 359)*ANG1
						local dist = 256
						local spd = P_RandomRange(40, 50)

						local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
						local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
						local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

						local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

						s.frame = A
						s.color = SKINCOLOR_CYAN
						s.scale = FRACUNIT*3/2
						s.destscale = FRACUNIT/5
						s.target = target
						s.tics = 10
						s.momx = (mo.x - s.x)/10
						s.momy = (mo.y - s.y)/10
						s.momz = (mo.z - s.z)/10

					elseif timer == 110
						return true
					end
				end,
}

attackDefs["vilna-ya"] = {
		name = "Vilna-ya",
		type = ATK_ALMIGHTY,
		power = 850,
		accuracy = 90,
		costtype = CST_SP,
		cost = 24,
		desc = "Severe Almighty damage\n to all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			local MYFUCKINGEARS

			for k,v in ipairs(hittargets)

				local target = v
				local time = timer - 6*(k-1)

				if time >= 20 and time <= 40

					if leveltime%3 == 0
						local thok = P_SpawnMobj(target.x + P_RandomRange(-200, 200)*FRACUNIT, target.y + P_RandomRange(-200, 200)*FRACUNIT, target.z + P_RandomRange(0, 200)<<FRACBITS, MT_DUMMY)
						thok.scale = FRACUNIT*3/2
						A_OldRingExplode(thok, MT_SUPERSPARK)
						thok.flags2 = $|MF2_DONTDRAW
						if not MYFUCKINGEARS
							playSound(mo.battlen, sfx_bufu3)
						end
						MYFUCKINGEARS = true

						local speeds = {FRACUNIT/16, FRACUNIT/10, FRACUNIT/3, FRACUNIT/8}
						local fuses = {20, 16, 8, 16}

						for i = 1, 2
							local l = P_SpawnMobj(thok.x, thok.y, thok.z + FRACUNIT*32, MT_THOK)	-- mt_thok for auto fadeout
							l.tics = -1
							l.sprite = SPR_CARD
							l.color = SKINCOLOR_WHITE
							l.frame = L|(i== 2 and TR_TRANS40 or TR_TRANS70)|FF_FULLBRIGHT
							l.scale = FRACUNIT/2
							l.destscale = FRACUNIT*6
							l.scalespeed = speeds[i]
							l.fuse = fuses[i]
						end

					end

					if time == 35
						damageObject(target)
					end
					for i = 1,8
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.state = S_SSPK1
						thok.momz = P_RandomRange(15, 30)*FRACUNIT
						thok.momx = P_RandomRange(-6, 6)*FRACUNIT
						thok.momy = P_RandomRange(-6, 6)*FRACUNIT
					end
				end
			end

			if timer == 60 + 6*(#hittargets-1)
				return true
			end
		end,
}

attackDefs["fors"] = {
		name = "Fors-yokin",
		type = ATK_PASSIVE|ATK_ALMIGHTY,
		desc = "Boost Almighty damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["kilati"] = {
		name = "Kilati",
		type = ATK_PASSIVE|ATK_CURSE,
		desc = "Boost Curse damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["blesatu"] = {
		name = "Blesatu",
		type = ATK_PASSIVE|ATK_BLESS,
		desc = "Boost Bless damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["jukait"] = {
		name = "Jukait",
		type = ATK_PASSIVE|ATK_SLASH,
		desc = "Boost Slash damage by 20%",
		power = 20,
		passive = PSV_BOOST,
}

attackDefs["goldenhalo"] = {
		name = "Golden Halo",
		type = ATK_BLESS,
		power = 700,
		accuracy = 90,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art\nSevere Bless damage to \nall enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies

				if timer == 10
					playSound(mo.battlen, sfx_hama3)

					-- get them cards ready

					-- first row
					mo.hcard = {}
					for i = 1, 6
						local ang = (360/6 *i)*ANG1
						local c = P_SpawnMobj(avgx + 256*cos(ang), avgy + 256*sin(ang), mo.z, MT_DUMMY)
						c.sprite = SPR_CARD
						c.frame = J|FF_FULLBRIGHT|FF_PAPERSPRITE
						c.angle = ang+ANG1*90
						c.tics = -1
						mo.hcard[#mo.hcard+1] = c
					end
				elseif timer == 20
					-- get them cards ready

					-- first row
					mo.hcard2 = {}
					for i = 1, 10
						local ang = (360/10 *i)*ANG1
						local c = P_SpawnMobj(avgx + 320*cos(ang), avgy + 320*sin(ang), mo.z, MT_DUMMY)
						c.sprite = SPR_CARD
						c.frame = J|FF_FULLBRIGHT|FF_PAPERSPRITE
						c.angle = ang+ANG1*90
						c.tics = -1
						c.scale = FRACUNIT/2
						mo.hcard2[#mo.hcard2+1] = c
					end
				end

				local ct = mo.hcard
				while ct

					for i = 1, #ct
						local c = ct[i]

						if c.appeartimer == nil
							c.appeartimer = 9
						end
						c.frame = J|FF_FULLBRIGHT|FF_PAPERSPRITE | (c.appeartimer<<FF_TRANSSHIFT)
						c.appeartimer = max(4, $-1)

						if timer >= TICRATE*3/2
						and leveltime & 1
							c.frame = K|FF_FULLBRIGHT|FF_PAPERSPRITE
						end

						if c.appeartimer <= 4

							c.rspeed = $ or 1
							if leveltime%4 == 0
								c.rspeed = min(25, $+1)
							end

							if ct == mo.hcard2
								c.angle = $ + c.rspeed*ANG1
							else
								c.angle = $ - c.rspeed*ANG1
							end	-- rotate

							--update pos

							if leveltime & 1
								local g = P_SpawnGhostMobj(c)
								g.fuse = 2
							end

							local dist = ct == mo.hcard2 and 320 or 256
							P_TeleportMove(c, avgx + dist*cos(c.angle - ANG1*90), avgy + dist*sin(c.angle - ANG1*90), c.z)
						end

						if timer == TICRATE*5/2
							P_InstaThrust(c, c.angle - ANG1*90, 48*FRACUNIT)
							c.fuse = TICRATE
						end
					end


					-- fuck you
					if ct == mo.hcard2
						break
					else
						ct = mo.hcard2
					end
				end

				if timer >= 20

					if timer == TICRATE
						playSound(mo.battlen, sfx_zio5)
					end

					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 256
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_WHITE
						aura.momz = P_RandomRange(4, 16)*FRACUNIT
						aura.scale = FRACUNIT*2
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
					end
				end

				if timer == TICRATE*5/2
					mo.hcard = nil
					mo.hcard2 = nil

					playSound(mo.battlen, sfx_hamas2)

					for k,v in ipairs(hittargets)
						damageObject(v)
					end
				end

				if timer >= TICRATE*5/2
				and timer <= TICRATE*4

					for i = 1, 16
						local boom = P_SpawnMobj(avgx + P_RandomRange(-48, 48)*FRACUNIT, avgy + P_RandomRange(-48, 48)*FRACUNIT, mo.z, MT_SUPERSPARK)
						boom.momz = P_RandomRange(16, 64)*FRACUNIT
						boom.scale = FRACUNIT*2
					end
				end

				if timer == TICRATE*4
					return true
				end
		end,
}

attackDefs["death_scream_alt"] = {
		name = "Death Scream",
		type = ATK_CURSE,
		power = 700,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art\nSevere curse damage to all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for i = 1,#hittargets
			local target = hittargets[i]
			local time = timer - 10*(i-1)
				if time == 25
					playSound(mo.battlen, sfx_eih3)
				end

				if time >= 20 and time <= 50
					for i = 1,6
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z + P_RandomRange(30, 60)<<FRACBITS, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_PURPLE
						if time%2 then thok.color = SKINCOLOR_BLACK end
						thok.tics = 35
						thok.scalespeed = FRACUNIT/32
						thok.destscale = 1
						thok.momz = P_RandomRange(-3, -1)*FRACUNIT
					end
				elseif time >= 51 and time <= 60
					if time == 52
						damageObject(target)
						for i = 1,16
							local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
							if i%2 then thok.color = SKINCOLOR_MAGENTA else thok.color = SKINCOLOR_BLACK end
							thok.frame = A
							thok.scale = FRACUNIT*2
							thok.destscale = 1
							thok.tics = 30
							thok.scalespeed = FRACUNIT/6
							thok.angle = ANGLE_22h*(i-1)
							P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
						end
					end

					if leveltime%4 == 0
						local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
						t.fuse = TICRATE/2
						t.sprite = SPR_MUDO
						t.tics = -1
						t.frame = C|TR_TRANS10
						t.color = leveltime%8 == 0 and SKINCOLOR_NEON or SKINCOLOR_BLACK
						t.scale = FRACUNIT/3
						t.destscale = FRACUNIT*3
						t.scalespeed = FRACUNIT/6
					end

					if leveltime%5 == 0
						local caman = R_PointToAngle(target.x, target.y)

						local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
						t.fuse = TICRATE/2
						t.sprite = SPR_MUDO
						t.tics = -1
						t.frame = D|TR_TRANS10
						t.color = SKINCOLOR_NEON
						t.scale = FRACUNIT/3
						t.destscale = FRACUNIT*3
						t.scalespeed = FRACUNIT/4
					end


					for i = 1,8
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.color = SKINCOLOR_NEON
						if time%2 then thok.color = SKINCOLOR_BLACK end
						if i == 1
							thok.color = SKINCOLOR_DUSK
						end
						thok.scale = FRACUNIT*2
						thok.frame = A
						thok.tics = 35
						thok.scalespeed = FRACUNIT/32
						thok.destscale = 1
						thok.momz = P_RandomRange(20, 35)*FRACUNIT
					end

				elseif time == 90
					return true
				end
			end
		end,
}

attackDefs["finaltrialmap"] = {
        name = "Loa's Map Loader",
        type = ATK_PASSIVE,
        desc = "Forces the map to change on the vision quest",
        passive = PSV_STARTBATTLE,
        anim = function(mo, targets, hittargets, timer)
            if G_BuildMapName() ~= "MAP45" //Nothing in () makes it check current map
                COM_BufInsertText(server, "map 45 -f") //Sends you to brazil... Maybe, literally?
            end //We didn't return true?!?! That's because PSV_STARTBATTLE only activates for ONE frame, and dont need no stinkn' returns
        end,
}

attackDefs["garkuti"] = {
        name = "Garkuti",
        type = ATK_PASSIVE,
        desc = "Nullify odds of being inflicted\non some status",
        passive = PSV_COND_RESIST,
        power = 100,
        status = COND_SHOCK|COND_BRAINWASH|COND_HEX|COND_SILENCE|COND_DESPAIR,
}