BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Special Support Section",
  description = {"Test your strength", "against Lloyd and Elie"},
  level = 85,
  music = "BARIR2",
  time = TICRATE*60*32,
  items = {{"tearalbalm", 30}, {"spcharge2", 15}, {"spcharge3", 10}, {"curiabalm", 15}, {"recuriabalm", 10}, {"revbalm", 10}, {"celbalm", 7}, {"hypercombiring", 15}, {"dekaja gem", 30}, {"soma", 3}},
  waves = {
			{"enemylloyd2", "enemyelie2"},
		},
}

BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Wind from Liberl",
  description = {"Test your strength", "against Estelle, Joshua and Tita"},
  level = 85,
  music = "SOFHT",
  time = TICRATE*60*32,
  items = {{"tearalbalm", 30}, {"spcharge2", 25}, {"spcharge3", 15}, {"curiabalm", 20}, {"recuriabalm", 15}, {"revbalm", 15}, {"celbalm", 15}, {"hypercombiring", 15}, {"stablet", 20}, {"dekaja gem", 30}, {"soma", 3}},
  waves = {
			{"enemyestelle2", "enemyjoshua2", "enemytita2"},
		},
}

BTL_challengebtllist[#BTL_challengebtllist+1] = {
  name = "The Trails Group",
  description = {"Battle against everyone", "in the Trails pack!"},
  level = 85,
  music = "SETHR",
  time = TICRATE*60*40,
  items = {{"tearalbalm", 40}, {"spcharge3", 35}, {"curiabalm", 30}, {"recuriabalm", 25}, {"revbalm", 30}, {"celbalm", 20}, {"hypercombiring", 20}, {"dekaja gem", 40}, {"stablet", 40}, {"soma", 5}},
  waves = {
			{"enemylloyd", "enemyestelle", "enemyjoshua", "enemytita", "enemyelie"},
		},
}

enemyList["enemylloyd"] = {
		name = "Lloyd",
		skillchance = 95,	-- /100, probability of using a skill
		level = 85,
		persona = "lloyd",
		melee_natk = "brave_smash",	-- normal melee attack
		melee_satk = "risingsun", //Let's gooooooooooooo
		
		supercolor_start = SKINCOLOR_SUPERLLOYD1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 2025,
		sp = 3630,
		strength = 50,
		magic = 30,
		endurance = 30,
		agility = 30,
		luck = 40,
		boss = true,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["risingsun"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 33300,
		weak = ATK_CURSE,
		resist = ATK_FIRE|ATK_NUCLEAR,

		skin = "lloyd",			-- for "player" fights.
		color = SKINCOLOR_CERULEAN,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATT, A, 8, "SPR2_BATT"},					-- standing
		anim_stand_hurt =	{SPR_BATT, A, 1, "SPR2_BATT"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATT, A, 8, "SPR2_BATT"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFD, A, 1, "SPR2_DEFD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LRIP, A, 1, "SPR2_LRIP"},					-- is down
		anim_getup =		{SPR_BATT, A, 1, "SPR2_BATT"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_LCHR, A, 8, "SPR2_LCHR"},
		anim_evoker_shoot = {SPR_LFIR, A, 8, "SPR2_LFIR"},
		anim_special1 =		{SPR_BATT, A, 1, "SPR2_BATT"},	-- charge
		anim_special2 =		{SPR_LHOP, A, 2, "SPR2_LHOP"},	-- dash
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"}, // Rising
		anim_special4 =		{SPR_PLAY, G, 35, "SPR2_TRNS"}, // SUUUUUN
		
		vfx_summon = {"sfx_llsmn1", "sfx_llsmn2", "sfx_llsmn3", "sfx_llsmn4", "sfx_llsmn5"},
		vfx_skill = {"sfx_llskl1", "sfx_llskl2", "sfx_llskl3", "sfx_llskl4"},
		vfx_item = {"sfx_llitem"},
		vfx_hurt = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_hurtx = {"sfx_llxhr", "sfx_llxhr2"},
		vfx_die = {"sfx_lldie", "sfx_lldie2"},
		vfx_heal = {"sfx_llheal", "sfx_llhel2", "sfx_llhels"},
		vfx_healself = {"sfx_llhels"},
		vfx_kill = {"sfx_llkil1", "sfx_llkil2", "sfx_llkil3"},
		vfx_1more = {"sfx_ll1mor", "sfx_ll1mo"},
		vfx_crit = {"sfx_llcrt1", "sfx_llcrt2", "sfx_llcrt3", "sfx_llcrt4"},
		vfx_aoaask = {"sfx_llaoi1", "sfx_llaoi2", "sfx_llaoi3"},
		vfx_aoado = {"sfx_llaoa1", "sfx_llaoa2", "sfx_llaoa3", "sfx_llaoa4"},
		vfx_aoarelent = {"sfx_llaor1"},
		vfx_miss = {"sfx_llmis1", "sfx_llmis2", "sfx_llmis3"},
		vfx_dodge = {"sfx_lldog1", "sfx_lldog2", "sfx_lldog3"},
		vfx_win = {"sfx_llwin1", "sfx_llwin2", "sfx_llwin3", "sfx_llwin4"},
		vfx_levelup = {"sfx_llkil2", "sfx_lllevl", "sfx_lllev2"},

		icon = "H_LYDICO",	-- icon for net select and other menus
		hudbust = "H_LYDBAR",			-- patch to draw on the stat hud
		hudaoa = "H_LYDAOA",	-- patch for all out attack hud
		hudcutin = "LLYD_A",	-- cut in
		aoa_quote = "Let's overcome this \nbarrier together!",
		
		skills = {"grail_locket", "tigercharge", bionis and "atlas_hammer" or "lord_inferno", "tearal", "zero_breaker", bionis and "titanic_roar" or "crimson_ray", "extend_hearts", "burning_heart", "iron fist"}
	}
	
enemyList["enemyestelle"] = {
		name = "Estelle",
		skillchance = 95,	-- /100, probability of using a skill
		level = 85,
		persona = "estelle",
		melee_natk = "staff_hit",
		melee_satk = "twheeloftime",

		supercolor_start = SKINCOLOR_SUPERORANGE1,

		atk = 33,
		acc = 90,
		crit = 2,
		
		hp = 2270,
		sp = 3320,
		strength = 40,
		magic = 50,
		endurance = 50,
		agility = 50,
		luck = 30,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep_alt"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["twheeloftime"], {enemies[P_RandomRange(1, #enemies)]} //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 43300,
		weak = ATK_CURSE|ATK_FIRE,
		resist = ATK_ICE|ATK_BLESS,

		skin = "estelle",			-- for "player" fights.
		color = SKINCOLOR_ORANGE,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_REDY, A, 8, "SPR2_REDY"},					-- standing
		anim_stand_hurt =	{SPR_REDY, A, 1, "SPR2_REDY"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_REDY, A, 8, "SPR2_REDY"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFE, A, 1, "SPR2_DEFE"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ERIP, A, 1, "SPR2_ERIP"},					-- is down
		anim_getup =		{SPR_REDY, A, 1, "SPR2_REDY"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_ECHR, A, 8, "SPR2_ECHR"},
		anim_evoker_shoot = {SPR_EFIR, A, 8, "SPR2_EFIR"},
		anim_special1 = 	{SPR_BASH, A, 2, "SPR2_BASH"}, -- hammer prep
		anim_special2 = 	{SPR_BASH, B, C, D, E, 2, "SPR2_BASH"}, -- hammer swing
		anim_special3 = 	{SPR_BASH, A, "SPR2_BASH"},	-- hammer swung
		
		vfx_summon = {"sfx_eesmn1", "sfx_eesmn2", "sfx_eesmn3"},
		vfx_skill = {"sfx_eeskl1", "sfx_eeskl2", "sfx_eeskl3", "sfx_eeskl4", "sfx_eeskl5"},
		vfx_item = {"sfx_eesmn2"},
		vfx_hurt = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_xhurt = {"sfx_eehrt5"},
		vfx_die = {"sfx_eedie", "sfx_eedie2"},
		vfx_heal = {"sfx_eeheal", "sfx_eehels"},
		vfx_healself = {"sfx_eehels"},
		vfx_kill = {"sfx_eekil1", "sfx_eekil2", "sfx_eekil3", "sfx_eekil4"},
		vfx_1more = {"sfx_ee1mor", "sfx_ee1mo"},
		vfx_crit = {"sfx_eecrt1", "sfx_eecrt2", "sfx_eecrt3", "sfx_eecrt4"},
		vfx_aoaask = {"sfx_eeaoi1", "sfx_eeaoi2", "sfx_eeaoi3", "sfx_eeaoi4"},
		vfx_aoado = {"sfx_eeaoa1", "sfx_eeaoa2", "sfx_eeaoa3", "sfx_eeaoa4", "sfx_eeaoa5"},
		vfx_aoarelent = {"sfx_eemis2"},
		vfx_miss = {"sfx_eemis1", "sfx_eemis2"},
		vfx_dodge = {"sfx_eedog"},
		vfx_win = {"sfx_eewin1", "sfx_eewin2", "sfx_eewin3", "sfx_eewin4"},
		vfx_levelup = {"sfx_eekil1", "sfx_eelevl", "sfx_eelev2"},

		icon = "H_ESTICO",	-- icon for net select and other menus
		hudbust = "H_ESTBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ESTAOA",	-- patch for all out attack hud
		hudcutin = "ESTL_A",	-- cut in
		aoa_quote = "Alright guys!Time for \nsome ul-tra-vio-lence!",
		
		skills = {"grail_locket", bionis and "maelstorm" or "diamond_nova", "la_tearal", "la_crest", bionis and "genesis_flood" or "cocytus", "swellinghope", "tearal"}//Can't have too many healing attacks..
	}

enemyList["enemyjoshua"] = {
		name = "Joshua",
		skillchance = 99,	-- /100, probability of using a skill
		level = 85,
		persona = "joshua",
		melee_natk = "slash_strike", 
		melee_satk = "phantomraid",
		
		supercolor_start = SKINCOLOR_SUPERJET1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 2295,
		sp = 3660,
		strength = 30,
		magic = 30,
		endurance = 50,
		agility = 40,
		luck = 20,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep_alt"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["phantomraid"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 300,
		weak = ATK_BLESS,
		resist = ATK_CURSE|ATK_WIND,

		skin = "joshua",			-- for "player" fights.
		color = SKINCOLOR_JET,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATJ, A, 8, "SPR2_BATJ"},					-- standing
		anim_stand_hurt =	{SPR_BATJ, A, 1, "SPR2_BATJ"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATJ, A, 8, "SPR2_BATJ"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFJ, A, 1, "SPR2_DEFJ"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_JBAL, A, B, C, D, E, F, 2, "SPR2_JBAL"},			-- attacking
		anim_aoa_end =		{SPR_JBAL, F, E, D, C, B, A, 2, "SPR2_JBAL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_JRIP, A, 1, "SPR2_JRIP"},					-- is down
		anim_getup =		{SPR_BATJ, A, 1, "SPR2_BATJ"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_JCHR, A, 8, "SPR2_JCHR"},
		anim_evoker_shoot = {SPR_JFIR, A, 8, "SPR2_JFIR"},
		anim_special1 =		{SPR_BATJ, A, 1, "SPR2_BATJ"},
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_FALL"},
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"},
		
		vfx_summon = {"sfx_josmn1", "sfx_josmn2", "sfx_josmn3", "sfx_josmn4"},
		vfx_skill = {"sfx_joskl1", "sfx_joskl2", "sfx_joskl3", "sfx_joskl4"},
		vfx_item = {"sfx_joitem"},
		vfx_hurt = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_hurtx = {"sfx_joxhrt"},
		vfx_die = {"sfx_jodie1", "sfx_jodie2"},
		vfx_heal = {"sfx_johel1", "sfx_johel2"},
		vfx_healself = {"sfx_johel1"},
		vfx_kill = {"sfx_jokil1", "sfx_jokil2", "sfx_jokil3"},
		vfx_1more = {"sfx_jo1mor", "sfx_jo1mo"},
		vfx_crit = {"sfx_jocrt1", "sfx_jocrt2", "sfx_jocrt3", "sfx_jocrt4"},
		vfx_aoaask = {"sfx_joaoi1", "sfx_joaoi2", "sfx_joaoi3", "sfx_joaoi4"},
		vfx_aoado = {"sfx_joaoa1", "sfx_joaoa2", "sfx_joaoa3", "sfx_joaoa4"},
		vfx_aoarelent = {"sfx_jomis3"},
		vfx_miss = {"sfx_jomis1", "sfx_jomis2", "sfx_jomis3"},
		vfx_dodge = {"sfx_jodog1", "sfx_jodog2"},
		vfx_win = {"sfx_jowin1", "sfx_jowin2", "sfx_jowin3", "sfx_jowin4"},
		vfx_levelup = {"sfx_jowin3", "sfx_jolevl"},

		icon = "H_JOSICO",	-- icon for net select and other menus
		hudbust = "H_JOSBAR",			-- patch to draw on the stat hud
		hudaoa = "H_JOSAOA",	-- patch for all out attack hud
		hudcutin = "JOSH_A",	-- cut in
		aoa_quote = "We will not fail!\nLet's finish them off!",
		
		skills = {"grail_locket", bionis and "last_disaster" or "abyss_fall", "sdual_strike", "orbal_down", "fangflicker", bionis and "claiomh_solarion" or "death_scream", "phantom_pain", "chrono_break", "energy_drain"}
}	

enemyList["enemytita"] = {
		name = "Tita",
		skillchance = 99,	-- /100, probability of using a skill
		level = 85,
		persona = "tita",
		melee_natk = "explosion",
		melee_satk = "satbeam",
		
		supercolor_start = SKINCOLOR_SUPERTITA1,

		atk = 46,
		acc = 85,
		crit = 1,
		
		hp = 2198,
		sp = 3427,
		strength = 30,
		magic = 30,
		endurance = 40,
		agility = 30,
		luck = 20,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep_alt"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["satbeam"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 300,
		weak = ATK_ICE,
		resist = ATK_NUCLEAR,

		skin = "tita",			-- for "player" fights.
		color = SKINCOLOR_RED,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATI, A, 8, "SPR2_BATI"},					-- standing
		anim_stand_hurt =	{SPR_BATI, A, 1, "SPR2_BATI"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATI, A, 8, "SPR2_BATI"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_TDEF, A, 1, "SPR2_TDEF"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_TRIP, A, 1, "SPR2_TRIP"},					-- is down
		anim_getup =		{SPR_BATI, A, 1, "SPR2_BATI"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_TCHR, A, 8, "SPR2_TCHR"},
		anim_evoker_shoot = {SPR_TFIR, A, 8, "SPR2_TFIR"},
		anim_special1 =		{SPR_TSAB, A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,S,S,T,U,V,W,W,W, 4, "SPR2_TSAB"}, //108 Frames, a note for da stoopid Zoraxua
		
		vfx_summon = {"sfx_tismn1", "sfx_tismn2", "sfx_tismn3"},
		vfx_skill = {"sfx_tiskl1", "sfx_tiskl2", "sfx_tiskl3", "sfx_tiskl4"},
		vfx_item = {"sfx_tidog1"}, //?
		vfx_hurt = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_hurtx = {"sfx_tixht"},
		vfx_die = {"sfx_tirip1", "sfx_tirip2"},
		vfx_heal = {"sfx_tihel1", "sfx_tihel2"},
		vfx_healself = {"sfx_tihel1"},
		vfx_kill = {"sfx_tikil1", "sfx_tikil2"},
		vfx_1more = {"sfx_ti1mo", "sfx_ti1mo2"},
		vfx_crit = {"sfx_ticrt1", "sfx_ticrt2", "sfx_ticrt3", "sfx_ticrt4"},
		vfx_aoaask = {"sfx_tiaoi1", "sfx_tiaoi2"},
		vfx_aoado = {"sfx_tiaoa1", "sfx_tiaoa2", "sfx_tiaoa3", "sfx_tiaoa4", "sfx_tiaoa5"},
		vfx_aoarelent = {"sfx_timis1", "sfx_timis2"},
		vfx_miss = {"sfx_timis1", "sfx_timis2", "sfx_timis3"},
		vfx_dodge = {"sfx_tidog1", "sfx_tidog2"},
		vfx_win = {"sfx_tiwin1", "sfx_tiwin2", "sfx_tiwin3", "sfx_tiwin4"},
		vfx_levelup = {"sfx_tilevl"},

		icon = "H_TITICO",	-- icon for net select and other menus
		hudbust = "H_TITBAR",			-- patch to draw on the stat hud
		hudaoa = "H_TITAOA",	-- patch for all out attack hud
		hudcutin = "TITA_A",	-- cut in
		aoa_quote = "P-Prepare to meet\nyour doom!",
		
		skills = {"grail_locket", bionis and "junk_blast" or "dark matter", bionis and "blast_force" or "altair cannon", "smokecannon2", "seventh caliber", "crescent mirror", bionis and "metal amp" or "nuke amp", bionis and "orbal_parts" or "zeruel_cannon", "chrono_drive"}
}

enemyList["enemyelie"] = {
		name = "Elie",
		skillchance = 99,	-- /100, probability of using a skill
		level = 85,
		persona = "elie",
		melee_natk = "revolver",	
		melee_satk = "aerialcannon",
		
		supercolor_start = SKINCOLOR_SUPERELIE1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 2496,
		sp = 3480,
		strength = 40,
		magic = 40,
		endurance = 40,
		agility = 40,
		luck = 20,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["aerialcannon"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		boss = true,
		r_exp = 300,
		weak = ATK_PSY,
		resist = ATK_WIND|ATK_ELEC,

		skin = "elie",			-- for "player" fights.
		color = SKINCOLOR_RASPBERRY,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing
		anim_stand_hurt =	{SPR_BATE, A, 1, "SPR2_BATE"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_ELDE, A, 1, "SPR2_ELDE"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_ELGN, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ELRP, A, 1, "SPR2_ELRP"},					-- is down
		anim_getup =		{SPR_BATE, A, 1, "SPR2_BATE"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_ELCH, A, 8, "SPR2_ELCH"},
		anim_evoker_shoot = {SPR_ELFI, A, 8, "SPR2_ELFI"},
		anim_special1 =		{SPR_ELGN, A, 1, "SPR2_ELGN"},
		
		vfx_summon = {"sfx_elsmn1", "sfx_elsmn2", "sfx_elsmn3", "sfx_elsmn4"},
		vfx_skill = {"sfx_elskl1", "sfx_elskl2", "sfx_elskl3", "sfx_elskl4"},
		vfx_item = {"sfx_elitem"},
		vfx_hurt = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_hurtx = {"sfx_elhrt2"},
		vfx_die = {"sfx_elrip"},
		vfx_heal = {"sfx_elhel1", "sfx_elhel2"},
		vfx_healself = {"sfx_eldog1"},
		vfx_kill = {"sfx_elkil1", "sfx_elkil2", "sfx_elkil3"},
		vfx_1more = {"sfx_el1mo", "sfx_el1mor"},
		vfx_crit = {"sfx_elcrt1", "sfx_elcrt2", "sfx_elcrt3", "sfx_elcrt4"},
		vfx_aoaask = {"sfx_elaoi1", "sfx_elaoi2"},
		vfx_aoado = {"sfx_elaoa1", "sfx_elaoa2"},
		vfx_aoarelent = {"sfx_eldog2"},
		vfx_miss = {"sfx_elmis1", "sfx_elmis2"},
		vfx_dodge = {"sfx_eldog1", "sfx_eldog2"},
		vfx_win = {"sfx_elwin1", "sfx_elwin2", "sfx_elwin3"},
		vfx_levelup = {"sfx_elkil2"},

		icon = "H_ELEICO",	-- icon for net select and other menus
		hudbust = "H_ELEBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ELEAOA",	-- patch for all out attack hud
		hudcutin = "ELIE_A",	-- cut in
		aoa_quote = "They are down!\nLet's go everyone!",
		
		skills = {"grail_locket", "judgement_bolt", "aero_storm", "triple_piercer", "antistepall", "ragna_vortex", "fortuna", "wind amp", "innocence_arc"}
}

enemyList["enemylloyd2"] = {
		name = "Lloyd",
		skillchance = 95,	-- /100, probability of using a skill
		level = 85,
		persona = "lloyd",
		melee_natk = "brave_smash",	-- normal melee attack
		melee_satk = "risingsun", //Let's gooooooooooooo
		
		supercolor_start = SKINCOLOR_SUPERLLOYD1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 5175,
		sp = 5300,
		strength = 50,
		magic = 40,
		endurance = 40,
		agility = 40,
		luck = 45,
		boss = true,
        thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["risingsun"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 33300,
		weak = ATK_CURSE,
		resist = ATK_FIRE|ATK_NUCLEAR,

		skin = "lloyd",			-- for "player" fights.
		color = SKINCOLOR_CERULEAN,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATT, A, 8, "SPR2_BATT"},					-- standing
		anim_stand_hurt =	{SPR_BATT, A, 1, "SPR2_BATT"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATT, A, 8, "SPR2_BATT"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFD, A, 1, "SPR2_DEFD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LRIP, A, 1, "SPR2_LRIP"},					-- is down
		anim_getup =		{SPR_BATT, A, 1, "SPR2_BATT"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_LCHR, A, 8, "SPR2_LCHR"},
		anim_evoker_shoot = {SPR_LFIR, A, 8, "SPR2_LFIR"},
		anim_special1 =		{SPR_BATT, A, 1, "SPR2_BATT"},	-- charge
		anim_special2 =		{SPR_LHOP, A, 2, "SPR2_LHOP"},	-- dash
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"}, // Rising
		anim_special4 =		{SPR_PLAY, G, 35, "SPR2_TRNS"}, // SUUUUUN
		
		vfx_summon = {"sfx_llsmn1", "sfx_llsmn2", "sfx_llsmn3", "sfx_llsmn4", "sfx_llsmn5"},
		vfx_skill = {"sfx_llskl1", "sfx_llskl2", "sfx_llskl3", "sfx_llskl4"},
		vfx_item = {"sfx_llitem"},
		vfx_hurt = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_hurtx = {"sfx_llxhr", "sfx_llxhr2"},
		vfx_die = {"sfx_lldie", "sfx_lldie2"},
		vfx_heal = {"sfx_llheal", "sfx_llhel2", "sfx_llhels"},
		vfx_healself = {"sfx_llhels"},
		vfx_kill = {"sfx_llkil1", "sfx_llkil2", "sfx_llkil3"},
		vfx_1more = {"sfx_ll1mor", "sfx_ll1mo"},
		vfx_crit = {"sfx_llcrt1", "sfx_llcrt2", "sfx_llcrt3", "sfx_llcrt4"},
		vfx_aoaask = {"sfx_llaoi1", "sfx_llaoi2", "sfx_llaoi3"},
		vfx_aoado = {"sfx_llaoa1", "sfx_llaoa2", "sfx_llaoa3", "sfx_llaoa4"},
		vfx_aoarelent = {"sfx_llaor1"},
		vfx_miss = {"sfx_llmis1", "sfx_llmis2", "sfx_llmis3"},
		vfx_dodge = {"sfx_lldog1", "sfx_lldog2", "sfx_lldog3"},
		vfx_win = {"sfx_llwin1", "sfx_llwin2", "sfx_llwin3", "sfx_llwin4"},
		vfx_levelup = {"sfx_llkil2", "sfx_lllevl", "sfx_lllev2"},

		icon = "H_LYDICO",	-- icon for net select and other menus
		hudbust = "H_LYDBAR",			-- patch to draw on the stat hud
		hudaoa = "H_LYDAOA",	-- patch for all out attack hud
		hudcutin = "LLYD_A",	-- cut in
		aoa_quote = "Let's overcome this \nbarrier together!",
		
		skills = {"grail_locket", "tigercharge", bionis and "atlas_hammer" or "lord_inferno", "tearal", "zero_breaker", bionis and "titanic_roar" or "crimson_ray", "extend_hearts", "burning_heart", "iron fist"}
	}
	
enemyList["enemyestelle2"] = {
		name = "Estelle",
		skillchance = 95,	-- /100, probability of using a skill
		level = 85,
		persona = "estelle",
		melee_natk = "staff_hit",
		melee_satk = "twheeloftime",

		supercolor_start = SKINCOLOR_SUPERORANGE1,

		atk = 33,
		acc = 90,
		crit = 2,
		
		hp = 4810,
		sp = 6320,
		strength = 40,
		magic = 60,
		endurance = 45,
		agility = 50,
		luck = 30,
		boss = true,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep_alt"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["twheeloftime"], {enemies[P_RandomRange(1, #enemies)]} //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 43300,
		weak = ATK_CURSE|ATK_FIRE,
		resist = ATK_ICE|ATK_BLESS,

		skin = "estelle",			-- for "player" fights.
		color = SKINCOLOR_ORANGE,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_REDY, A, 8, "SPR2_REDY"},					-- standing
		anim_stand_hurt =	{SPR_REDY, A, 1, "SPR2_REDY"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_REDY, A, 8, "SPR2_REDY"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFE, A, 1, "SPR2_DEFE"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, C, B, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ERIP, A, 1, "SPR2_ERIP"},					-- is down
		anim_getup =		{SPR_REDY, A, 1, "SPR2_REDY"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_ECHR, A, 8, "SPR2_ECHR"},
		anim_evoker_shoot = {SPR_EFIR, A, 8, "SPR2_EFIR"},
		anim_special1 = 	{SPR_BASH, A, 2, "SPR2_BASH"}, -- hammer prep
		anim_special2 = 	{SPR_BASH, B, C, D, E, 2, "SPR2_BASH"}, -- hammer swing
		anim_special3 = 	{SPR_BASH, A, "SPR2_BASH"},	-- hammer swung
		
		vfx_summon = {"sfx_eesmn1", "sfx_eesmn2", "sfx_eesmn3"},
		vfx_skill = {"sfx_eeskl1", "sfx_eeskl2", "sfx_eeskl3", "sfx_eeskl4", "sfx_eeskl5"},
		vfx_item = {"sfx_eesmn2"},
		vfx_hurt = {"sfx_eehrt1", "sfx_eehrt2", "sfx_eehrt3", "sfx_eehrt4", "sfx_eehrt5"},
		vfx_xhurt = {"sfx_eehrt5"},
		vfx_die = {"sfx_eedie", "sfx_eedie2"},
		vfx_heal = {"sfx_eeheal", "sfx_eehels"},
		vfx_healself = {"sfx_eehels"},
		vfx_kill = {"sfx_eekil1", "sfx_eekil2", "sfx_eekil3", "sfx_eekil4"},
		vfx_1more = {"sfx_ee1mor", "sfx_ee1mo"},
		vfx_crit = {"sfx_eecrt1", "sfx_eecrt2", "sfx_eecrt3", "sfx_eecrt4"},
		vfx_aoaask = {"sfx_eeaoi1", "sfx_eeaoi2", "sfx_eeaoi3", "sfx_eeaoi4"},
		vfx_aoado = {"sfx_eeaoa1", "sfx_eeaoa2", "sfx_eeaoa3", "sfx_eeaoa4", "sfx_eeaoa5"},
		vfx_aoarelent = {"sfx_eemis2"},
		vfx_miss = {"sfx_eemis1", "sfx_eemis2"},
		vfx_dodge = {"sfx_eedog"},
		vfx_win = {"sfx_eewin1", "sfx_eewin2", "sfx_eewin3", "sfx_eewin4"},
		vfx_levelup = {"sfx_eekil1", "sfx_eelevl", "sfx_eelev2"},

		icon = "H_ESTICO",	-- icon for net select and other menus
		hudbust = "H_ESTBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ESTAOA",	-- patch for all out attack hud
		hudcutin = "ESTL_A",	-- cut in
		aoa_quote = "Alright guys!Time for \nsome ul-tra-vio-lence!",
		
		skills = {"grail_locket", bionis and "maelstorm" or "diamond_nova", "la_tearal", "la_crest", bionis and "genesis_flood" or "cocytus", "swellinghope", "tearal"}//Can't have too many healing attacks..
	}

enemyList["enemyjoshua2"] = {
		name = "Joshua",
		skillchance = 99,	-- /100, probability of using a skill
		level = 85,
		persona = "joshua",
		melee_natk = "slash_strike", 
		melee_satk = "phantomraid",
		
		supercolor_start = SKINCOLOR_SUPERJET1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 3885,
		sp = 5260,
		strength = 48,
		magic = 40,
		endurance = 55,
		agility = 60,
		luck = 30,
		boss = true,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep_alt"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["phantomraid"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 43300,
		weak = ATK_BLESS,
		resist = ATK_CURSE|ATK_WIND,

		skin = "joshua",			-- for "player" fights.
		color = SKINCOLOR_JET,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATJ, A, 8, "SPR2_BATJ"},					-- standing
		anim_stand_hurt =	{SPR_BATJ, A, 1, "SPR2_BATJ"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATJ, A, 8, "SPR2_BATJ"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFJ, A, 1, "SPR2_DEFJ"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_JBAL, A, B, C, D, E, F, 2, "SPR2_JBAL"},			-- attacking
		anim_aoa_end =		{SPR_JBAL, F, E, D, C, B, A, 2, "SPR2_JBAL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_JRIP, A, 1, "SPR2_JRIP"},					-- is down
		anim_getup =		{SPR_BATJ, A, 1, "SPR2_BATJ"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_JBAL, F, E, D, C, B, A, 2, "SPR2_JBAL"},			-- gets revived
		anim_evoker =		{SPR_JCHR, A, 8, "SPR2_JCHR"},
		anim_evoker_shoot = {SPR_JFIR, A, 8, "SPR2_JFIR"},
		anim_special1 =		{SPR_BATJ, A, 1, "SPR2_BATJ"},
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_FALL"},
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"},
		
		vfx_summon = {"sfx_josmn1", "sfx_josmn2", "sfx_josmn3", "sfx_josmn4"},
		vfx_skill = {"sfx_joskl1", "sfx_joskl2", "sfx_joskl3", "sfx_joskl4"},
		vfx_item = {"sfx_joitem"},
		vfx_hurt = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_hurtx = {"sfx_joxhrt"},
		vfx_die = {"sfx_jodie1", "sfx_jodie2"},
		vfx_heal = {"sfx_johel1", "sfx_johel2"},
		vfx_healself = {"sfx_johel1"},
		vfx_kill = {"sfx_jokil1", "sfx_jokil2", "sfx_jokil3"},
		vfx_1more = {"sfx_jo1mor", "sfx_jo1mo"},
		vfx_crit = {"sfx_jocrt1", "sfx_jocrt2", "sfx_jocrt3", "sfx_jocrt4"},
		vfx_aoaask = {"sfx_joaoi1", "sfx_joaoi2", "sfx_joaoi3", "sfx_joaoi4"},
		vfx_aoado = {"sfx_joaoa1", "sfx_joaoa2", "sfx_joaoa3", "sfx_joaoa4"},
		vfx_aoarelent = {"sfx_jomis3"},
		vfx_miss = {"sfx_jomis1", "sfx_jomis2", "sfx_jomis3"},
		vfx_dodge = {"sfx_jodog1", "sfx_jodog2"},
		vfx_win = {"sfx_jowin1", "sfx_jowin2", "sfx_jowin3", "sfx_jowin4"},
		vfx_levelup = {"sfx_jowin3", "sfx_jolevl"},

		icon = "H_JOSICO",	-- icon for net select and other menus
		hudbust = "H_JOSBAR",			-- patch to draw on the stat hud
		hudaoa = "H_JOSAOA",	-- patch for all out attack hud
		hudcutin = "JOSH_A",	-- cut in
		aoa_quote = "We will not fail!\nLet's finish them off!",
		
		skills = {"grail_locket", bionis and "last_disaster" or "abyss_fall", "sdual_strike", "orbal_down", "fangflicker", bionis and "claiomh_solarion" or "death_scream", "phantom_pain", "chrono_break", "energy_drain"}
}

enemyList["enemytita2"] = {
		name = "Tita",
		skillchance = 95,	-- /100, probability of using a skill
		level = 85,
		persona = "tita",
		melee_natk = "explosion",
		melee_satk = "satbeam",
		
		supercolor_start = SKINCOLOR_SUPERTITA1,

		atk = 46,
		acc = 85,
		crit = 1,
		
		hp = 4258,
		sp = 5007,
		strength = 40,
		magic = 50,
		endurance = 60,
		agility = 40	,
		luck = 30,
		boss = true,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep_alt"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["satbeam"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 300,
		weak = ATK_ICE,
		resist = ATK_NUCLEAR,

		skin = "tita",			-- for "player" fights.
		color = SKINCOLOR_RED,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATI, A, 8, "SPR2_BATI"},					-- standing
		anim_stand_hurt =	{SPR_BATI, A, 1, "SPR2_BATI"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATI, A, 8, "SPR2_BATI"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_TDEF, A, 1, "SPR2_TDEF"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_TRIP, A, 1, "SPR2_TRIP"},					-- is down
		anim_getup =		{SPR_BATI, A, 1, "SPR2_BATI"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_TCHR, A, 8, "SPR2_TCHR"},
		anim_evoker_shoot = {SPR_TFIR, A, 8, "SPR2_TFIR"},
		anim_special1 =		{SPR_TSAB, A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,S,S,T,U,V,W,W,W, 4, "SPR2_TSAB"}, //108 Frames, a note for da stoopid Zoraxua
		
		vfx_summon = {"sfx_tismn1", "sfx_tismn2", "sfx_tismn3"},
		vfx_skill = {"sfx_tiskl1", "sfx_tiskl2", "sfx_tiskl3", "sfx_tiskl4"},
		vfx_item = {"sfx_tidog1"}, //?
		vfx_hurt = {"sfx_tihrt1", "sfx_tihrt2", "sfx_tihrt3", "sfx_tihrt4"},
		vfx_hurtx = {"sfx_tixht"},
		vfx_die = {"sfx_tirip1", "sfx_tirip2"},
		vfx_heal = {"sfx_tihel1", "sfx_tihel2"},
		vfx_healself = {"sfx_tihel1"},
		vfx_kill = {"sfx_tikil1", "sfx_tikil2"},
		vfx_1more = {"sfx_ti1mo", "sfx_ti1mo2"},
		vfx_crit = {"sfx_ticrt1", "sfx_ticrt2", "sfx_ticrt3", "sfx_ticrt4"},
		vfx_aoaask = {"sfx_tiaoi1", "sfx_tiaoi2"},
		vfx_aoado = {"sfx_tiaoa1", "sfx_tiaoa2", "sfx_tiaoa3", "sfx_tiaoa4", "sfx_tiaoa5"},
		vfx_aoarelent = {"sfx_timis1", "sfx_timis2"},
		vfx_miss = {"sfx_timis1", "sfx_timis2", "sfx_timis3"},
		vfx_dodge = {"sfx_tidog1", "sfx_tidog2"},
		vfx_win = {"sfx_tiwin1", "sfx_tiwin2", "sfx_tiwin3", "sfx_tiwin4"},
		vfx_levelup = {"sfx_tilevl"},

		icon = "H_TITICO",	-- icon for net select and other menus
		hudbust = "H_TITBAR",			-- patch to draw on the stat hud
		hudaoa = "H_TITAOA",	-- patch for all out attack hud
		hudcutin = "TITA_A",	-- cut in
		aoa_quote = "P-Prepare to meet\nyour doom!",
		
		skills = {"grail_locket", bionis and "junk_blast" or "dark matter", bionis and "blast_force" or "altair cannon", "smokecannon2", "seventh caliber", "crescent mirror", bionis and "metal amp" or "nuke amp", bionis and "orbal_parts" or "zeruel_cannon", "chrono_drive"}
}

enemyList["enemyelie2"] = {
		name = "Elie",
		skillchance = 99,	-- /100, probability of using a skill
		level = 85,
		persona = "elie",
		melee_natk = "revolver",	
		melee_satk = "aerialcannon",
		
		supercolor_start = SKINCOLOR_SUPERELIE1,

		atk = 40,
		acc = 90,
		crit = 5,
		
		hp = 5149,
		sp = 5480,
		strength = 50,
		magic = 52,
		endurance = 42,
		agility = 40,
		luck = 30,
		boss = true,
		thinker =     function(mo)
                        //S-Craft thinker
                        //Zoraxua note: This is really simple tbh
                        local enemies = mo.enemies
                        
                        if mo.hp < mo.maxhp*1/2 //Half health?
                            if not mo.healed //Lets prep first
                                mo.healed = true
                                return attackDefs["scraftprep"], {mo} //I'll give the skill
                            elseif not mo.scraft //Okay, now BAP once!
                                mo.scraft = true //Insert satk name in box below
                                return attackDefs["aerialcannon"], enemies //For Estelle, use {enemies[P_RandomRange(1, #enemies)]}
                            end    
                        end//And otherwise,
                        return generalEnemyThinker(mo)
                    end,
		r_exp = 43300,
		weak = ATK_PSY,
		resist = ATK_WIND|ATK_ELEC,

		skin = "elie",			-- for "player" fights.
		color = SKINCOLOR_RASPBERRY,	-- for colormapping


		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing
		anim_stand_hurt =	{SPR_BATE, A, 1, "SPR2_BATE"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_ELDE, A, 1, "SPR2_ELDE"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_ELGN, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ELRP, A, 1, "SPR2_ELRP"},					-- is down
		anim_getup =		{SPR_BATE, A, 1, "SPR2_BATE"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_ELCH, A, 8, "SPR2_ELCH"},
		anim_evoker_shoot = {SPR_ELFI, A, 8, "SPR2_ELFI"},
		anim_special1 =		{SPR_ELGN, A, 1, "SPR2_ELGN"},
		
		vfx_summon = {"sfx_elsmn1", "sfx_elsmn2", "sfx_elsmn3", "sfx_elsmn4"},
		vfx_skill = {"sfx_elskl1", "sfx_elskl2", "sfx_elskl3", "sfx_elskl4"},
		vfx_item = {"sfx_elitem"},
		vfx_hurt = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_hurtx = {"sfx_elhrt2"},
		vfx_die = {"sfx_elrip"},
		vfx_heal = {"sfx_elhel1", "sfx_elhel2"},
		vfx_healself = {"sfx_eldog1"},
		vfx_kill = {"sfx_elkil1", "sfx_elkil2", "sfx_elkil3"},
		vfx_1more = {"sfx_el1mo", "sfx_el1mor"},
		vfx_crit = {"sfx_elcrt1", "sfx_elcrt2", "sfx_elcrt3", "sfx_elcrt4"},
		vfx_aoaask = {"sfx_elaoi1", "sfx_elaoi2"},
		vfx_aoado = {"sfx_elaoa1", "sfx_elaoa2"},
		vfx_aoarelent = {"sfx_eldog2"},
		vfx_miss = {"sfx_elmis1", "sfx_elmis2"},
		vfx_dodge = {"sfx_eldog1", "sfx_eldog2"},
		vfx_win = {"sfx_elwin1", "sfx_elwin2", "sfx_elwin3"},
		vfx_levelup = {"sfx_elkil2"},

		icon = "H_ELEICO",	-- icon for net select and other menus
		hudbust = "H_ELEBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ELEAOA",	-- patch for all out attack hud
		hudcutin = "ELIE_A",	-- cut in
		aoa_quote = "They are down!\nLet's go everyone!",
		
		skills = {"grail_locket", "judgement_bolt", "aero_storm", "triple_piercer", "antistepall", "ragna_vortex", "fortuna", "wind amp", "innocence_arc"}
}

attackDefs["scraftprep"] = {
		name = "S-Craft Preparation",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 0,
		desc = "Trails Chars only\nPrepares to use their S-Craft.\nDoes nothing.It's just visual",
		target = TGT_CASTER,
        anim = function(mo, targets, hittargets, timer)
            local target = hittargets[1]

            if timer == 20
                playSound(mo.battlen, sfx_scraft)
                for i = 1,16
                    local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                    dust.angle = ANGLE_90 + ANG1* (22*(i-1))
                    dust.state = S_CDUST1
                    P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
                    dust.color = SKINCOLOR_RED
                    dust.scale = FRACUNIT*2
                end

            elseif timer > 15 and timer <= 70


                for i = 1, 8
                    local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
                    thok.sprite = SPR_SUMN
                    thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
                    thok.momz = P_RandomRange(6, 16)*FRACUNIT
                    thok.color = SKINCOLOR_RED
                    thok.tics = P_RandomRange(10, 35)
                end
            end
            if timer == 35
                BTL_logMessage(mo.battlen, mo.name.." is charging a powerful attack...")
                VFX_Play(mo, VFX_CRIT)
            elseif timer == 70
                return true
            end
        end,
    }
	
freeslot("sfx_scrft2")

attackDefs["scraftprep_alt"] = {
		name = "Preparing S-Craft",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 0,
		desc = "Trails Chars only\nPrepares to use their S-Craft.\nDoes nothing.It's just visual",
		target = TGT_CASTER,
        anim = function(mo, targets, hittargets, timer)
            local target = hittargets[1]

            if timer == 20
                playSound(mo.battlen, sfx_scrft2)
                for i = 1,16
                    local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
                    dust.angle = ANGLE_90 + ANG1* (22*(i-1))
                    dust.state = S_CDUST1
                    P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
                    dust.color = SKINCOLOR_RED
                    dust.scale = FRACUNIT*2
                end

            elseif timer > 15 and timer <= 70


                for i = 1, 8
                    local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
                    thok.sprite = SPR_SUMN
                    thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
                    thok.momz = P_RandomRange(6, 16)*FRACUNIT
                    thok.color = SKINCOLOR_RED
                    thok.tics = P_RandomRange(10, 35)
                end
            end
            if timer == 35
                BTL_logMessage(mo.battlen, mo.name.." is charging a powerful attack...")
                VFX_Play(mo, VFX_CRIT)
            elseif timer == 70
                return true
            end
        end,
    }
	
attackDefs["grail_locket"] = {
        name = "Grail Locket",
        type = ATK_PASSIVE,
        desc = "Nullify odds of being inflicted\nby shock,brainwash,sleep,\nsilence,despair and rage",
        passive = PSV_COND_RESIST,
        power = 100,
        status = COND_SHOCK|COND_BRAINWASH|COND_SLEEP|COND_SILENCE|COND_DESPAIR|COND_RAGE,
}

if bionis
    enemyList["enemylloyd"].weak = $|ATK_METAL|ATK_WATER
	enemyList["enemylloyd"].resist = $|ATK_EARTH
end

if bionis
    enemyList["enemylloyd2"].weak = $|ATK_METAL|ATK_WATER
	enemyList["enemylloyd2"].resist = $|ATK_EARTH
end

if bionis
    enemyList["enemyestelle"].weak = $|ATK_EARTH
	enemyList["enemyestelle"].resist = $|ATK_WATER
end	

if bionis
    enemyList["enemyestelle2"].weak = $|ATK_EARTH
	enemyList["enemyestelle2"].resist = $|ATK_WATER
end	

if bionis
	enemyList["enemyjoshua"].weak = $|ATK_FOREST
	enemyList["enemyjoshua"].resist = $|ATK_GRAVITY
end

if bionis
	enemyList["enemyjoshua2"].weak = $|ATK_FOREST
	enemyList["enemyjoshua2"].resist = $|ATK_GRAVITY
end

if bionis
    enemyList["enemytita"].weak = $|ATK_POISON
	enemyList["enemytita"].resist = $|ATK_GRAVITY
end

if bionis
    enemyList["enemytita2"].weak = $|ATK_POISON
	enemyList["enemytita2"].resist = $|ATK_GRAVITY
end

if bionis
    enemyList["enemyelie"].weak = $|ATK_POISON
	enemyList["enemyelie"].resist = $|ATK_FOREST
end

if bionis
    enemyList["enemyelie2"].weak = $|ATK_POISON
	enemyList["enemyelie2"].resist = $|ATK_FOREST
end