freeslot("MT_TRAILSWIND")

mobjinfo[MT_TRAILSWIND] = {
	-1,
	S_INVISIBLE,
	0,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	0,
	32 * FRACUNIT,
	32 * FRACUNIT,
	0,
	0,
	0,
	sfx_None,
	MF_NOBLOCKMAP|MF_NOGRAVITY,
	S_NULL
}

addHook("MobjThinker", function(mo)

	local target = mo.target
	if not target return end
	if not target.valid return end

	if not mo.alivefor then mo.alivefor = 1 else mo.alivefor = min(16, $+2) end

	local sx = mo.x + mo.dist*cos(mo.angle)
	local sy = mo.y + mo.dist*sin(mo.angle)

	if mo.invertrotation
		mo.angle = $+ ANG1*40
		if not mo.momz then mo.momz = -8*FRACUNIT end
	else
		mo.angle = $ - ANG1*40
		if not mo.momz then mo.momz = 8*FRACUNIT end
	end

	if not (leveltime%4)
		mo.momz = -mo.momz
	end

	local qualityfactor = 1
	if mo.lowquality then qualityfactor = 2 end

	if not mo.fakeangle
		mo.fakeangle = P_RandomRange(0, 359)*ANG1
	end

	for i = 1,mo.alivefor / qualityfactor
		local ref = ANG1*2 * qualityfactor
		if not mo.invertrotation then ref = -ref end

		local sx = mo.x + mo.dist*cos(mo.angle - (ref)*i)
		local sy = mo.y + mo.dist*sin(mo.angle - (ref)*i)
		local sz = mo.z + 16*sin(mo.angle - (ref)*i - mo.fakeangle)

		local trail = P_SpawnMobj(sx, sy, sz, MT_THOK)
		trail.frame = A|FF_FULLBRIGHT
		trail.scale = FRACUNIT/3
		trail.scalespeed = $
		trail.destscale = 1

		if mo.tics == 1
			trail.angle = mo.angle - (ref)*i + ANGLE_90
			P_InstaThrust(trail, trail.angle, FRACUNIT*70)
			trail.tics = 7
		end

		if mo.jizzcolor
			trail.color = SKINCOLOR_MINT
		else
			trail.color = SKINCOLOR_LIME
		end
	end
end, MT_TRAILSWIND)